routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('welcome');
});

Auth::routes();

Route::get('/home', 'HomeController@index')->name('home');
Route::group(['middleware' => 'auth'], function() {
	Route::resource('products', 'ProductsController', ['only' => ['index']]);
	Route::resource('stock_entries', 'StockEntriesController', ['only' => ['index', 'create', 'store']]);
	Route::resource('stock_outputs', 'StockOutputsController', ['only' => ['index', 'create', 'store']]);
	Route::resource('orders', 'OrdersController', ['only' => ['create','store']]);
});

app/Order.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Order extends Model
{
    public function products()
    {
    	return $this->hasMany(OrderProduct::class);
    }

    public function user()
    {
    	return $this->belongsTo(User::class);
    }
}

app/OrderProduct.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;
use App\Events\OrderProductCreated;

class OrderProduct extends Model
{
    protected $casts = [
    	'price' => 'float',
    	'quantity' => 'integer'
    ];

    protected $events = [
    	'created' => OrderProductCreated::class
    ];

    public function product()
    {
    	return $this->belongsTo(Product::class);
    }
}

app/Product.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;
use App\Events\ProductUpdating;

class Product extends Model
{
    protected $fillable = [
    	'name',
    	'stock',
    	'stock_max',
    	'price_sale',
    	'price_purchase'
    ];

    protected $events = [
    	'updating' 	=> ProductUpdating::class
    ];
}

app/StockEntry.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;
use App\Events\StockEntryCreated;

class StockEntry extends Model
{
    use StockMovements;

    protected $events = [
    	'created' 	=> StockEntryCreated::class,
    ];
}

app/StockMovements.php
<?php

namespace App;

trait StockMovements
{
	public function product()
	{
		return $this->belongsTo(Product::class);
	}
}

app/StockOutput.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;
use App\Events\StockOutputCreated;

class StockOutput extends Model
{
    use StockMovements;

    protected $events = [
    	'created' => StockOutputCreated::class
    ];
}

app/User.php
<?php

namespace App;

use Illuminate\Notifications\Notifiable;
use Illuminate\Foundation\Auth\User as Authenticatable;

class User extends Authenticatable
{
    use Notifiable;

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'name', 'email', 'password',
    ];

    /**
     * The attributes that should be hidden for arrays.
     *
     * @var array
     */
    protected $hidden = [
        'password', 'remember_token',
    ];
}

app/Http/Controllers/Controller.php
<?php

namespace App\Http\Controllers;

use Illuminate\Foundation\Bus\DispatchesJobs;
use Illuminate\Routing\Controller as BaseController;
use Illuminate\Foundation\Validation\ValidatesRequests;
use Illuminate\Foundation\Auth\Access\AuthorizesRequests;

class Controller extends BaseController
{
    use AuthorizesRequests, DispatchesJobs, ValidatesRequests;
}

app/Http/Controllers/HomeController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;

class HomeController extends Controller
{
    /**
     * Create a new controller instance.
     *
     * @return void
     */
    public function __construct()
    {
        $this->middleware('auth');
    }

    /**
     * Show the application dashboard.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        return view('home');
    }
}

app/Http/Controllers/OrdersController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Order;
use App\OrderProduct;
use App\Product;
use App\Events\OrderProductsSaveCompleted;

class OrdersController extends Controller
{
    public function create()
    {
    	$products = Product::all()->random(4);
    	return view('orders.create', compact('products'));
    }

    public function store(Request $request)
    {
    	$order = Order::forceCreate([
    		'user_id' => \Auth::user()->id
    	]);

    	foreach ($request->get('products') as $orderProduct) {
    		$product = Product::find($orderProduct['product_id']);
    		OrderProduct::forceCreate([
    			'order_id' => $order->id,
    			'product_id' => $product->id,
    			'price' => $product->price_sale,
    			'quantity' => $orderProduct['quantity']
    		]);
    	}

        event(new OrderProductsSaveCompleted($order));

    	return view('orders.successfully', compact('order'));
    }
}

app/Http/Controllers/ProductsController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Product;

class ProductsController extends Controller
{
    public function index()
    {
    	$products = Product::all();
    	return view('products.index', compact('products'));
    }
}

app/Http/Controllers/StockEntriesController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Product;
use App\StockEntry;

class StockEntriesController extends Controller
{
    public function index()
    {
    	$movements = StockEntry::all();
    	return view('stock-entries.index', compact('movements'));
    }

    public function create()
    {
    	$products = Product::all()->pluck('name','id');
    	return view('stock-entries.create', compact('products'));
    }

    public function store(Request $request)
    {
    	$data = array_except($request->all(), '_token');
        StockEntry::forceCreate($data);

    	return redirect()->route('stock_entries.index');
    }
}

app/Http/Controllers/StockOutputsController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Product;
use App\StockOutput;

class StockOutputsController extends Controller
{
    public function index()
    {
    	$movements = StockOutput::all();
    	return view('stock-outputs.index', compact('movements'));
    }

    public function create()
    {
    	$products = Product::all()->pluck('name','id');
    	return view('stock-outputs.create', compact('products'));
    }

    public function store(Request $request)
    {
    	$data = array_except($request->all(), '_token');
    	StockOutput::forceCreate($data);
    	return redirect()->route('stock_outputs.index');
    }
}

resources/views/home.blade.php
@extends('layouts.app')

@section('content')
<div class="container">
    <div class="row">
        <div class="col-md-8 col-md-offset-2">
            <div class="panel panel-default">
                <div class="panel-heading">Dashboard</div>

                <div class="panel-body">
                    @if (session('status'))
                        <div class="alert alert-success">
                            {{ session('status') }}
                        </div>
                    @endif

                    You are logged in!
                </div>
            </div>
        </div>
    </div>
</div>
@endsection

resources/views/layouts/app.blade.php
<!DOCTYPE html>
<html lang="{{ app()->getLocale() }}">
<head>
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">

    <!-- CSRF Token -->
    <meta name="csrf-token" content="{{ csrf_token() }}">

    <title>{{ config('app.name', 'Laravel') }}</title>

    <!-- Styles -->
    <link href="{{ asset('css/app.css') }}" rel="stylesheet">
</head>
<body>
    <div id="app">
        <nav class="navbar navbar-default navbar-static-top">
            <div class="container">
                <div class="navbar-header">

                    <!-- Collapsed Hamburger -->
                    <button type="button" class="navbar-toggle collapsed" data-toggle="collapse" data-target="#app-navbar-collapse">
                        <span class="sr-only">Toggle Navigation</span>
                        <span class="icon-bar"></span>
                        <span class="icon-bar"></span>
                        <span class="icon-bar"></span>
                    </button>

                    <!-- Branding Image -->
                    <a class="navbar-brand" href="{{ url('/') }}">
                        {{ config('app.name', 'Laravel') }}
                    </a>
                </div>

                <div class="collapse navbar-collapse" id="app-navbar-collapse">
                    <!-- Left Side Of Navbar -->
                    <ul class="nav navbar-nav">
                        <li><a href="{{route('products.index')}}">Produto</a></li>
                        <li><a href="{{route('orders.create')}}">Checkout</a></li>
                        <li><a href="{{route('stock_entries.index')}}">Entrada de Estoque</a></li>
                        <li><a href="{{route('stock_outputs.index')}}">Saída de Estoque</a></li>
                        &nbsp;
                    </ul>

                    <!-- Right Side Of Navbar -->
                    <ul class="nav navbar-nav navbar-right">
                        <!-- Authentication Links -->
                        @if (Auth::guest())
                            <li><a href="{{ route('login') }}">Login</a></li>
                            <li><a href="{{ route('register') }}">Register</a></li>
                        @else
                            <li class="dropdown">
                                <a href="#" class="dropdown-toggle" data-toggle="dropdown" role="button" aria-expanded="false">
                                    {{ Auth::user()->name }} <span class="caret"></span>
                                </a>

                                <ul class="dropdown-menu" role="menu">
                                    <li>
                                        <a href="{{ route('logout') }}"
                                            onclick="event.preventDefault();
                                                     document.getElementById('logout-form').submit();">
                                            Logout
                                        </a>

                                        <form id="logout-form" action="{{ route('logout') }}" method="POST" style="display: none;">
                                            {{ csrf_field() }}
                                        </form>
                                    </li>
                                </ul>
                            </li>
                        @endif
                    </ul>
                </div>
            </div>
        </nav>

        @yield('content')
    </div>

    <!-- Scripts -->
    <script src="{{ asset('js/app.js') }}"></script>
</body>
</html>

resources/views/orders/create.blade.php
@extends('layouts.app')

@section('content')
    <div class="container">
        <div class="row">
            <h3>Checkout</h3>
            {!! Form::open(['url' => route('orders.store'),'method' => 'POST']) !!}
            <div class="form-group">
                {!! Form::submit('Criar',['class' => 'btn btn-primary']) !!}
            </div>
            <table class="table table-bordered">
                <thead>
                <tr>
                    <th>Produto</th>
                    <td>Quant.</td>
                    <td>Price.</td>
                </tr>
                </thead>
                <tbody>
                @foreach($products as $product)
                    <tr>
                        <td>
                            {!! Form::hidden("products[{$loop->index}][product_id]",$product->id) !!}
                            {{ $product->name  }}
                        </td>
                        <td>
                            {!! Form::hidden("products[{$loop->index}][quantity]",$quantity = rand(1,2)) !!}
                            {{ $quantity }}
                        </td>
                        <td>
                            {!! Form::hidden("products[{$loop->index}][price]",$product->price_sale) !!}
                            {{ $product->price_sale }}
                        </td>
                    </tr>
                @endforeach
                </tbody>
            </table>
            {!! Form::close() !!}
        </div>
    </div>
@endsection

resources/views/orders/successfully.blade.php
@extends('layouts.app')

@section('content')
    <div class="container">
        <h3>Sua compra foi efetuada com sucesso</h3>
        <p>Order: {{$order->id}}</p>
        <p>Total: R$ {{$order->total}}</p>
    </div>
@endsection

resources/views/products/index.blade.php
@extends('layouts.app')

@section('content')
    <div class="container">
        <div class="row">
            <h3>Products</h3>
            <table class="table table-bordered">
                <thead>
                <tr>
                    <th style="width: 10px;">#</th>
                    <th>Nome</th>
                    <th>Quant.</th>
                    <th>Quant. Max.</th>
                    <th>Preço Venda</th>
                    <th>Preço Compra</th>
                </tr>
                </thead>
                <tbody>
                @foreach($products as $product)
                    <tr>
                        <td>{{ $product->id  }}</td>
                        <td>{{ $product->name }}</td>
                        <td>{{ $product->stock }}</td>
                        <td>{{ $product->stock_max }}</td>
                        <td>{{ $product->price_sale }}</td>
                        <td>{{ $product->price_purchase }}</td>
                    </tr>
                @endforeach
                </tbody>
            </table>
        </div>
    </div>
@endsection

resources/views/receipt/order-completed.blade.php
<div>
    <div>
        <h3>Comprovante de pagamento - {{config('app.name')}}</h3>
        <p>Data: {{$order->created_at}}</p>
        <p>Total: {{$order->total}}</p>
        <table>
            <thead>
            <tr>
                <th>Produto</th>
                <td>Quant.</td>
                <td>Price.</td>
            </tr>
            </thead>
            <tbody>
            @foreach($order->products as $product)
                <tr>
                    <td>{{ $product->product->name  }}</td>
                    <td>{{ $product->quantity }}</td>
                    <td>{{ $product->price }}</td>
                </tr>
            @endforeach
            </tbody>
        </table>
    </div>
</div>

resources/views/stock-entries/create.blade.php
@extends('layouts.app')

@section('content')
    <div class="container">
        <div class="row">
            <h3>Criar entrada</h3>
            {!! Form::open(['url' => route('stock_entries.store'),'method' => 'POST']) !!}
                @include('stock-movements._create')
            {!! Form::close() !!}
        </div>
    </div>
@endsection

resources/views/stock-entries/index.blade.php
@extends('layouts.app')

@section('content')
    <div class="container">
        <div class="row">
            <h3>Entradas de Estoque</h3>
            <a href="{{route('stock_entries.create')}}" class="btn btn-primary">Novo</a>
        </div>
        <br/>
        @include('stock-movements._index')
    </div>
@endsection

resources/views/stock-movements/_create.blade.php
<div class="form-group">
    {!! Form::label('quantity', 'Quant.', ['class' => 'control-label']) !!}
    {!! Form::text('quantity', null, ['class' => 'form-control']) !!}
</div>
<div class="form-group">
    {!! Form::label('product_id', 'Produto', ['class' => 'control-label']) !!}
    {!! Form::select('product_id',$products, null, ['class' => 'form-control']) !!}
</div>
<div class="form-group">
    {!! Form::submit('Criar',['class' => 'btn btn-primary']) !!}
</div>

resources/views/stock-movements/_index.blade.php
<div class="row">
    <table class="table table-bordered">
        <thead>
        <tr>
            <th style="width: 10px;">#</th>
            <th>Quant.</th>
            <th>Produto</th>
            <th>Estoque</th>
        </tr>
        </thead>
        <tbody>
        @foreach($movements as $movement)
            <tr>
                <td>{{ $movement->id  }}</td>
                <td>{{ $movement->quantity }}</td>
                <td>{{ $movement->product->name }}</td>
                <td>{{ $movement->product->stock }}</td>
            </tr>
        @endforeach
        </tbody>
    </table>
</div>

resources/views/stock-outputs/create.blade.php
@extends('layouts.app')

@section('content')
    <div class="container">
        <div class="row">
            <h3>Criar saída</h3>
            {!! Form::open(['url' => route('stock_outputs.store'),'method' => 'POST']) !!}
                @include('stock-movements._create')
            {!! Form::close() !!}
        </div>
    </div>
@endsection

resources/views/stock-outputs/index.blade.php
@extends('layouts.app')

@section('content')
    <div class="container">
        <div class="row">
            <h3>Saídas de Estoque</h3>
            <a href="{{route('stock_outputs.create')}}" class="btn btn-primary">Novo</a>
        </div>
        <br/>
        @include('stock-movements._index')
    </div>
@endsection